
// D/Objective-C Cocoa Bindings
// Copyright © 2011  Michel Fortin
// <http://michelf.com/d-objc/>
//
// This file is published under the terms of the Boost Software License 1.0.
//
// Boost Software License - Version 1.0 - August 17th, 2003
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
//
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

module appkit.event;

import appkit.window;

import foundation.runtime;
import foundation.object;
import foundation.string;
import foundation.geometry;
import foundation.date;
	

extern (Objective-C)
class NSEvent : NSObject {	
	// Event type
	enum Type {
	   LEFT_MOUSE_DOWN		= 1,
	   LEFT_MOUSE_UP		= 2,
	   RIGHT_MOUSE_DOWN		= 3,
	   RIGHT_MOUSE_UP		= 4,
	   MOUSE_MOVED			= 5,
	   LEFT_MOUSE_DRAGGED	= 6,
	   RIGHT_MOUSE_DRAGGED	= 7,
	   MOUSE_ENTERED		= 8,
	   MOUSE_EXITED			= 9,
	   KEY_DOWN				= 10,
	   KEY_UP				= 11,
	   FLAGS_CHANGED		= 12,
	   APPKIT_DEFINED		= 13,
	   SYSTEM_DEFINED		= 14,
	   APPLICATION_DEFINED	= 15,
	   PERIODIC				= 16,
	   CURSOR_UPDATE		= 17,
	   SCROLL_WHEEL			= 22,
	   TABLET_POINT			= 23,
	   TABLET_PROXIMITY		= 24,
	   OTHER_MOUSE_DOWN		= 25,
	   OTHER_MOUSE_UP		= 26,
	   OTHER_MOUSE_DRAGGED	= 27
	}
	
//	NSGraphicsContext context() @property [context];

	@property {
		NSPoint locationInWindow() [locationInWindow];
		NSUInteger modifierFlags() [modifierFlags];
		NSTimeInterval timestamp() [timestamp];
		Type type() [type];
		NSWindow window() [window];
	}
		
	
	// Key event info
	
	@property {
		NSString characters() [characters];
		NSString charactersIgnoringModifiers() [charactersIgnoringModifiers];
		
		bool isARepeat() [isARepeat];
		ushort keyCode() [keyCode];
	}
	
	static NSPoint mouseLocation() @property [mouseLocation];
	
	@property {
		NSInteger buttonNumber() [buttonNumber];
		NSInteger clickCount() [clickCount];
	
		float pressure() [pressure];
	}
	
	@property {
		NSInteger data1() [data1];
		NSInteger data2() [data2];
	
		short subType() [subType];
	}
	
	@property {
		float deltaX() [deltaX];
		float deltaY() [deltaY];
		float deltaZ() [deltaZ];
	}

}