
// D/Objective-C Cocoa Bindings
// Copyright © 2011  Michel Fortin
// <http://michelf.com/d-objc/>
//
// This file is published under the terms of the Boost Software License 1.0.
//
// Boost Software License - Version 1.0 - August 17th, 2003
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
//
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

module appkit.responder;

import appkit.event;
import appkit.menu;

import foundation.object;
import foundation.string;
import foundation.array;


extern (Objective-C)
class NSResponder : NSObject {

	bool acceptsFirstResponder() @property [acceptsFirstResponder];
	bool becomeFirstResponder() [becomeFirstResponder];
	bool resignFirstResponder() [resignFirstResponder];
	
	@property {
		NSResponder nextResponder() [nextResponder];
		void nextResponder(NSResponder next) [setNextResponder:];
	}
		
	// Mouse event handlers
	
	void mouseDown(NSEvent event) [mouseDown:];
	void mouseDragged(NSEvent event) [mouseDragged:];
	void mouseEntered(NSEvent event) [mouseEntered:];
	void mouseExited(NSEvent event) [mouseExited:];
	void mouseMoved(NSEvent event) [mouseMoved:];
	void mouseUp(NSEvent event) [mouseUp:];
	void rightMouseDown(NSEvent event) [rightMouseDown:];
	void rightMouseDragged(NSEvent event) [rightMouseDragged:];
	void rightMouseUp(NSEvent event) [rightMouseUp:];
	void otherMouseDown(NSEvent event) [otherMouseDown:];
	void otherMouseDragged(NSEvent event) [otherMouseDragged:];
	void otherMouseUp(NSEvent event) [otherMouseUp:];
	void scrollWell(NSEvent event) [scrollWell:];
	bool shouldBeTreatedAsInkEvent(NSEvent event) [shouldBeTreatedAsInkEvent:];


	// Key events

	void keyDown(NSEvent event) [keyDown:];
	void keyUp(NSEvent event) [keyUp:];
	void flagsChanged(NSEvent event) [flagsChanged:];
	void interpretKeyEvents(NSArray events) [interpretKeyEvents:];
	bool performKeyEquivalent(NSEvent event) [performKeyEquivalent:];
	bool performMnemonic(NSString mnemonic) [performMnemonic:];
	void flushBufferedKeyEvents() [flushBufferedKeyEvents];
	
	
	// Other events
	
	void helpRequested(NSEvent event) [helpRequested:];
	void tabletPoint(NSEvent event) [tabletPoint:];
	void tabletProximity(NSEvent event) [tabletProximity:];
	
	
	
	void doCommandWithSelector(objc.runtime.SEL selector) [doCommandWithSelector:];
	bool tryToPerform(objc.runtime.SEL selector, Object object) [tryToPerform:with:];
	void noResponderFor(objc.runtime.SEL selector) [noResponderFor:];
	
	Object validRequestorForSendType(NSString sentType, NSString returnType) [validRequestorForSendType:returnType:];
	
	@property {
		void menu(NSMenu menu) [setMenu:];
		NSMenu menu() [menu];
	}
	
//	@property {
//		NSUndoManager undoManager();
//	}
//	
//	bool presentError(NSError error) [presentError:];
//	bool presentError(NSError error, NSWindow window, ObjcObject deleg, void __selector(bool didRecover, void* contextInfo) didPresentSelector, void* contextInfo) [presentError:modalForWindow:delegate:didPresentSelector:contextInfo:];
//	NSError willPresentError(NSError error) [willPresentError:];
	
}