
// D/Objective-C Cocoa Bindings
// Copyright © 2011  Michel Fortin
// <http://michelf.com/d-objc/>
//
// This file is published under the terms of the Boost Software License 1.0.
//
// Boost Software License - Version 1.0 - August 17th, 2003
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
//
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

module foundation.date;

import foundation.object;
import foundation.string;
//import foundation.dictionary;
import foundation.runtime;


alias double NSTimeInterval;

extern (Objective-C)
class NSDate : NSObject {
	/** Create a new date with current time. */
	this() [init];
	
	/** Create a new date from string. */
	this(NSString string) [initWithString:];
		
	/** Create a new date from time interval since reference date. */
	this(NSTimeInterval interval) [initWithTimeIntervalSinceReferenceDate:];
	
	/** Create a new date from time interval since date. */
	this(NSTimeInterval interval, NSDate date) [initWithTimeInterval:sinceDate:];
	
	
	static NSDate distantFuture() @property [distantFuture];
	static NSDate distantPast() @property [distantPast];
	
	
	NSDate opAdd(NSTimeInterval interval) [addTimeInterval:];
	
	bool isEqualToDate(NSDate other) [isEqualToDate:];
	
	NSDate earlierDate(NSDate other) [earlierDate:];
	NSDate laterDate(NSDate other) [laterDate:];
	
	NSComparisonResult compare(NSDate other) [compare:];
	
	
	NSTimeInterval timeIntervalSince(NSDate date) [timeIntervalSinceDate:];
	
	@property {
		NSTimeInterval timeIntervalSince1970() [timeIntervalSince1970];
		NSTimeInterval timeIntervalSinceReferenceDate() [timeIntervalSinceReferenceDate];
	}
		
	
//	NSString descriptionWithCalendarFormat(NSString format, NSTimeZone timeZone, NSDictionary locale) {
//		return invokeObjcSuper!(NSString, "descriptionWithCalendarFormat:timeZone:locale:")(format, timeZone, locale);
//	}
	
//	NSString descriptionWithLocale(NSDictionary locale) [descriptionWithLocale:];
		
}