
// D/Objective-C Cocoa Bindings
// Copyright © 2011  Michel Fortin
// <http://michelf.com/d-objc/>
//
// This file is published under the terms of the Boost Software License 1.0.
//
// Boost Software License - Version 1.0 - August 17th, 2003
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
//
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

module foundation.zone;

import foundation.object;
import foundation.string;

private struct _NSZone;
alias _NSZone NSZone;

extern (C) {

	NSZone* NSDefaultMallocZone();
	NSZone* NSCreateZone(uint startSize, uint granularity, byte canFree);
	void NSRecycleZone(NSZone* zone);
	void NSSetZoneName(NSZone* zone, NSString name);
	NSString NSZoneName(NSZone* zone);
	NSZone NSZoneFromPointer(void* ptr);

	void* NSZoneMalloc(NSZone* zone, uint size);
	void* NSZoneCalloc(NSZone* zone, uint numElems, uint byteSize);
	void* NSZoneRealloc(NSZone* zone, void* ptr, uint size);
	void NSZoneFree(NSZone* zone, void* ptr);

	enum {
		NSScannedOption = (1<<0)
	}

	version (AVAILABLE_MAC_OS_X_VERSION_10_4_AND_LATER)
	void* NSAllocateCollectable(uint size, uint options);
	
	version (AVAILABLE_MAC_OS_X_VERSION_10_4_AND_LATER)
	void* NSReallocateCollectable(void* ptr, uint size, uint options);

	uint NSPageSize();
	uint NSLogPageSize();
	uint NSRoundUpToMultipleOfPageSize(uint bytes);
	uint NSRoundDownToMultipleOfPageSize(uint bytes);
	void* NSAllocateMemoryPages(uint bytes);
	void NSDeallocateMemoryPages(void* ptr, uint bytes);
	void NSCopyMemoryPages(void* source, void* dest, uint bytes);
	uint NSRealMemoryAvailable();

}